package ch.zhaw.gartenverwaltung;

import ch.zhaw.gartenverwaltung.backgroundtasks.email.SmtpCredentials;
import ch.zhaw.gartenverwaltung.types.HardinessZone;
import javafx.beans.property.BooleanProperty;
import javafx.beans.property.SimpleBooleanProperty;

import java.util.List;

public class Settings {
    private static final Settings instance;
    private HardinessZone currentHardinessZone = HardinessZone.ZONE_8A;
    private final BooleanProperty showTutorial = new SimpleBooleanProperty(false);
    private SmtpCredentials smtpCredentials = new SmtpCredentials("imap.gmail.com", "587", "pm3.hs22.it21b.win.team1@gmail.com", "pm3.hs22.it21b.win.team1@gmail.com", "bisefhhjtrrhtoqr", true);
    // Gmail Address: pm3.hs22.it21b.win.team1@gmail.com
    // Gmail Passwort: Gartenverwaltung.PM3.2022
    // E-Mail Inbox: https://www.mailinator.com/v4/public/inboxes.jsp?to=pm3.hs22.it21b.win.team1
    private String mailNotificationReceivers = "pm3.hs22.it21b.win.team1@mailinator.com";
    private String mailNotificationSubjectTemplate = "Task %s is due!"; // {0} = Task Name
    private String mailNotificationTextTemplate = "Dear user\nYour gardentask %s for plant %s is due at %tF. Don't forget to confirm in your application if the task is done.\nTask description:\n%s"; // {0} = Task Name, {1} = plantname, {2} = nextExecution, {3} = Task description

    static {
        instance = new Settings();
    }

    public static Settings getInstance() {
        return Settings.instance;
    }

    private Settings() {}

    public HardinessZone getCurrentHardinessZone() {
        return currentHardinessZone;
    }

    public void setCurrentHardinessZone(HardinessZone currentHardinessZone) {
        this.currentHardinessZone = currentHardinessZone;
    }

    public void setShowTutorial (boolean showTutorial) {
        this.showTutorial.setValue(showTutorial);
    }

    public BooleanProperty getShowTutorialProperty() {
        return this.showTutorial;
    }

    public boolean getShowTutorial() {
        return this.showTutorial.get();
    }

    public SmtpCredentials getSmtpCredentials() {
        return smtpCredentials;
    }

    public String getMailNotificationReceivers() {
        return mailNotificationReceivers;
    }

    public String getMailNotificationSubjectTemplate() {
        return mailNotificationSubjectTemplate;
    }

    public String getMailNotificationTextTemplate() {
        return mailNotificationTextTemplate;
    }
}
